// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlShortcutsWindow")]
    pub struct ShortcutsWindow(Object<ffi::DzlShortcutsWindow, ffi::DzlShortcutsWindowClass>) @extends gtk::Window, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_shortcuts_window_get_type(),
    }
}

impl ShortcutsWindow {
    pub const NONE: Option<&'static ShortcutsWindow> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::ShortcutsWindow>> Sealed for T {}
}

pub trait ShortcutsWindowExt: IsA<ShortcutsWindow> + sealed::Sealed + 'static {
    #[doc(alias = "section-name")]
    fn section_name(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "section-name")
    }

    #[doc(alias = "section-name")]
    fn set_section_name(&self, section_name: Option<&str>) {
        ObjectExt::set_property(self.as_ref(), "section-name", section_name)
    }

    #[doc(alias = "view-name")]
    fn view_name(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "view-name")
    }

    #[doc(alias = "view-name")]
    fn set_view_name(&self, view_name: Option<&str>) {
        ObjectExt::set_property(self.as_ref(), "view-name", view_name)
    }

    #[doc(alias = "close")]
    fn connect_close<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn close_trampoline<P: IsA<ShortcutsWindow>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlShortcutsWindow,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ShortcutsWindow::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"close\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    close_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_close(&self) {
        self.emit_by_name::<()>("close", &[]);
    }

    #[doc(alias = "search")]
    fn connect_search<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn search_trampoline<P: IsA<ShortcutsWindow>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlShortcutsWindow,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ShortcutsWindow::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"search\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    search_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_search(&self) {
        self.emit_by_name::<()>("search", &[]);
    }

    #[doc(alias = "section-name")]
    fn connect_section_name_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_section_name_trampoline<
            P: IsA<ShortcutsWindow>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlShortcutsWindow,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ShortcutsWindow::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::section-name\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_section_name_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "view-name")]
    fn connect_view_name_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_view_name_trampoline<
            P: IsA<ShortcutsWindow>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlShortcutsWindow,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(ShortcutsWindow::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::view-name\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_view_name_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<ShortcutsWindow>> ShortcutsWindowExt for O {}

impl fmt::Display for ShortcutsWindow {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ShortcutsWindow")
    }
}
